Package org.apache.sysds.hops

# Class IndexingOp

java.lang.Object
org.apache.sysds.hops.Hop
org.apache.sysds.hops.IndexingOp

All Implemented Interfaces:
  `ParseInfo`

public class IndexingOp extends Hop

## Field Summary

Fields
Modifier and Type
Field
Description
`static String`
`OPSTRING`

### Fields inherited from class org.apache.sysds.hops.Hop

`_beginColumn, _beginLine, _endColumn, _endLine, _filename, _text, CPThreshold`

## Constructor Summary

Constructors
Constructor
Description
`IndexingOp(String l, Types.DataType dt, Types.ValueType vt, Hop inpMatrix, Hop inpRowL, Hop inpRowU, Hop inpColL, Hop inpColU, boolean passedRowsLEU, boolean passedColsLEU)`

## Method Summary

Modifier and Type
Method
Description
`boolean`
`allowsAllExecTypes()`
`Object`
`clone()`
`boolean`
`compare(Hop that)`
`void`
`computeMemEstimate(MemoTable memo)`
Computes the estimate of memory required to store the input/output of this hop in memory.
`Lop`
`constructLops()`
`String`
`getOpString()`
`boolean`
`isAllCols()`
`boolean`
`isAllRows()`
`boolean`
`isAllRowsAndCols()`
`boolean`
`isColLowerEqualsUpper()`
`boolean`
`isGPUEnabled()`
In memory-based optimizer mode (see OptimizerUtils.isMemoryBasedOptLevel()), the exectype is determined by checking this method as well as memory budget of this Hop.
`boolean`
`isRowLowerEqualsUpper()`
`boolean`
`isScalarOutput()`
`void`
`refreshSizeInformation()`
Update the output size information for this hop.
`void`
`setColLowerEqualsUpper(boolean passed)`
`void`
`setRowLowerEqualsUpper(boolean passed)`

### Methods inherited from class org.apache.sysds.hops.Hop

`activatePrefetch, addAllInputs, addInput, checkAndSetForcedPlatform, checkAndSetInvalidCPDimsAndSize, clearMemEstimate, colsKnown, compressedSize, computeBoundsInformation, computeBoundsInformation, computeBoundsInformation, computeSizeInformation, computeSizeInformation, computeSizeInformation, constructAndSetLopsDataFlowProperties, createOffsetLop, deactivatePrefetch, dimsKnown, dimsKnown, dimsKnownAny, getBeginColumn, getBeginLine, getBlocksize, getCompressedSize, getDataCharacteristics, getDataType, getDim, getDim1, getDim2, getEndColumn, getEndLine, getExecType, getFederatedOutput, getFilename, getForcedExecType, getHopID, getInput, getInput, getInputMemEstimate, getInputMemEstimate, getInputOutputSize, getIntermediateMemEstimate, getLength, getLops, getMemEstimate, getName, getNnz, getOutputMemEstimate, getOutputMemEstimate, getParent, getSparsity, getSpBroadcastSize, getText, getUpdateType, getValueType, hasCompressedInput, hasFederatedOutput, hasLocalOutput, hasValidCPDimsAndSize, isCompressedOutput, isFederated, isFederatedDataOp, isMatrix, isMemEstimated, isOutputEmptyBlocks, isRequiredDecompression, isScalar, isTransposeSafe, isVisited, prefetchActivated, printErrorLocation, refreshColsParameterInformation, refreshColsParameterInformation, refreshMemEstimates, refreshRowsParameterInformation, refreshRowsParameterInformation, requiresCheckpoint, requiresCompression, requiresLineageCaching, requiresReblock, requiresRecompile, resetExecType, resetRecompilationFlag, resetRecompilationFlag, resetVisitStatus, resetVisitStatus, resetVisitStatus, resetVisitStatusForced, rowsKnown, setBeginColumn, setBeginLine, setBlocksize, setCompressedOutput, setCompressedSize, setDataType, setDim, setDim1, setDim2, setEndColumn, setEndLine, setExecType, setFederatedOutput, setFilename, setForcedExecType, setLops, setMemEstimate, setName, setNnz, setOutputEmptyBlocks, setParseInfo, setRequiresCheckpoint, setRequiresCompression, setRequiresCompression, setRequiresDeCompression, setRequiresLineageCaching, setRequiresReblock, setRequiresRecompile, setText, setUpdateType, setValueType, setVisited, setVisited, someInputFederated, toString, updateLopFedOut, updateLopFedOut`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Field Details

### OPSTRING

public static String OPSTRING

## Constructor Details

### IndexingOp

public IndexingOp(String l, Types.DataType dt, Types.ValueType vt, Hop inpMatrix, Hop inpRowL, Hop inpRowU, Hop inpColL, Hop inpColU, boolean passedRowsLEU, boolean passedColsLEU)

## Method Details

### isScalarOutput

public boolean isScalarOutput()

### isRowLowerEqualsUpper

public boolean isRowLowerEqualsUpper()

### isColLowerEqualsUpper

public boolean isColLowerEqualsUpper()

### setRowLowerEqualsUpper

public void setRowLowerEqualsUpper(boolean passed)

### setColLowerEqualsUpper

public void setColLowerEqualsUpper(boolean passed)

### isGPUEnabled

public boolean isGPUEnabled()
Description copied from class: `Hop`
In memory-based optimizer mode (see OptimizerUtils.isMemoryBasedOptLevel()), the exectype is determined by checking this method as well as memory budget of this Hop. Please see findExecTypeByMemEstimate for more detail. This method is necessary because not all operator are supported efficiently on GPU (for example: operations on frames and scalar as well as operations such as table).

Specified by:
  `isGPUEnabled` in class `Hop`
Returns:
  true if the Hop is eligible for GPU Exectype.

### constructLops

public Lop constructLops()

Specified by:
  `constructLops` in class `Hop`

### getOpString

public String getOpString()

Specified by:
  `getOpString` in class `Hop`

### allowsAllExecTypes

public boolean allowsAllExecTypes()

Specified by:
  `allowsAllExecTypes` in class `Hop`

### computeMemEstimate

public void computeMemEstimate(MemoTable memo)
Description copied from class: `Hop`
Computes the estimate of memory required to store the input/output of this hop in memory. This is the default implementation (orchestration of hop-specific implementation) that should suffice for most hops. If a hop requires more control, this method should be overwritten with awareness of (1) output estimates, and (2) propagation of worst-case matrix characteristics (dimensions, sparsity). TODO remove memo table and, on constructor refresh, inference in refresh, single compute mem, maybe general computeMemEstimate, flags to indicate if estimate or not.

Overrides:
  `computeMemEstimate` in class `Hop`
Parameters:
  `memo` - memory table

### refreshSizeInformation

public void refreshSizeInformation()
Description copied from class: `Hop`
Update the output size information for this hop.

Specified by:
  `refreshSizeInformation` in class `Hop`

### isAllRowsAndCols

public boolean isAllRowsAndCols()

### isAllRows

public boolean isAllRows()

### isAllCols

public boolean isAllCols()

### clone

public Object clone() throws CloneNotSupportedException

Specified by:
  `clone` in class `Hop`
Throws:
  `CloneNotSupportedException`

### compare

public boolean compare(Hop that)

Specified by:
  `compare` in class `Hop`